<template>
    <div class="user-edit">
        <div :class="{input:true, 'input--opacity': opacity ? opacity != 'surname' : false}">
            <label class="input__label input__label--small">Surname</label>
            <input type="text"
                   :value="user.surname"
                   class="input__text input__text--underline"
                   @keyup.enter="changeUser(user.id, 'surname', $event)"
                   @click="inputFocus('surname')"/>
            <i class="fa fa-pencil input__icon" aria-hidden="true" v-show="opacity ? opacity != 'surname' : true"></i>
        </div>

        <div :class="{input:true, 'input--opacity': opacity ? opacity != 'name' : false}">
            <label class="input__label input__label--small">Name</label>
            <input type="text"
                   :value="user.name"
                   class="input__text input__text--underline"
                   @keyup.enter="changeUser(user.id, 'name', $event)"
                   @click="inputFocus('name')"/>
            <i class="fa fa-pencil input__icon" aria-hidden="true" v-show="opacity ? opacity != 'name' : true"></i>
        </div>

        <div :class="{input:true, 'input--opacity': opacity ? opacity != 'company_name' : false}">
            <label class="input__label input__label--small">Company</label>
            <input type="text"
                   :value="user.company_name"
                   class="input__text input__text--underline"
                   @keyup.enter="changeUser(user.id, 'company_name', $event)"
                   @click="inputFocus('company_name')"/>
            <i class="fa fa-pencil input__icon" aria-hidden="true" v-show="opacity ? opacity != 'company_name' : true"></i>
        </div>

        <div :class="{input:true, 'input--opacity':opacity ? opacity != 'email' : false}">
            <label class="input__label input__label--small">Email address</label>
            <input type="text"
                   :value="user.email"
                   class="input__text input__text--underline"
                   @keyup.enter="changeUser(user.id, 'email', $event)"
                   @click="inputFocus('email')"/>
            <i class="fa fa-pencil input__icon" aria-hidden="true" v-show="opacity ? opacity != 'email' : true"></i>
        </div>

        <div :class="{input:true, 'input--opacity': opacity ? opacity != 'mobile_number' : false}">
            <label class="input__label input__label--small">Phone number</label>
            <input type="text"
                   :value="user.mobile_number"
                   class="input__text input__text--underline"
                   @keyup.enter="changeUser(user.id, 'mobile_number', $event)"
                   @click="inputFocus('mobile_number')"/>
            <i class="fa fa-pencil input__icon" aria-hidden="true" v-show="opacity ? opacity != 'mobile_number' : true"></i>
        </div>

        <div :class="{input:true, 'input--opacity': opacity ? opacity != 'job_title' : false}">
            <label class="input__label input__label--small">Job title</label>
            <input type="text"
                   :value="user.job_title"
                   class="input__text input__text--underline"
                   @keyup.enter="changeUser(user.id, 'job_title', $event)"
                   @click="inputFocus('job_title')"/>
            <i class="fa fa-pencil input__icon" aria-hidden="true" v-show="opacity ? opacity != 'job_title' : true"></i>
        </div>
    </div>
</template>

<script>
    import getData from '../mixins/getData'

    export default {
        name: 'EditUser',
        mixins: [getData],
        data() {
            return {
                opacity: false
            }
        },
        props: {
            user: {
                required: true
            }
        },
        methods: {
            inputFocus(name) {
                this.opacity = name
            },
            changeUser(id, input, event) {
                this.asyncGetData({
                    method: 'PUT',
                    url: 'admin/edit/user',
                    data: {
                        user_id: id,
                        input,
                        value: event.target.value
                    }
                }).then(response => {
                    if (response.status) {
                        this.users = response.data

                        this.user[input] = event.target.value

                        // Success message
                        this.$message({
                            message: input + ' successfully changed.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            }
        }
    }
</script>